# treeviz
A header-only C library which uses [graphviz](https://www.graphviz.org/) to
visualize recursive data structures.

This library is intended mostly for debugging purposes, as it can oftentimes
be useful to visualize your program's data layout. This is especially true with
deeply nested recursive data structures.

The methods in this library use two functions that end-user must write
themselves:

1. One that iterates over a node's children,
1. And another that represents a node's data.

This design allows the library to work with **any recursive data structure.**
As it turns out, these two functions are all you need to generalize the task
of visualization.

## Dependencies
You must have graphviz installed, and the `dot` executable in your path. That's
it.

*Optional:* Becuase this library renders your tree to a pdf (for now), it is
nice to have a pdf viewer that updates the screen automatically upon an update
to the file being viewed. [Zathura](https://github.com/pwmt/zathura) is one such
viewer, but there are many available.

## TODO: write documentation
There are some notes in the header file that may guide you before I write the
actual docs.

---
Copyright (C) Noah Swerhun under the terms of the LGPLv3 (see LICENSE.txt).
